Attribute VB_Name = "modDOSKey"
Option Explicit

Private Declare Function CharToOem Lib "user32" Alias "CharToOemA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Private Declare Function MapVirtualKey Lib "user32" Alias "MapVirtualKeyA" (ByVal wCode As Long, ByVal wMapType As Long) As Long
Private Declare Function OemKeyScan Lib "user32" (ByVal wOemChar As Integer) As Long
Private Declare Function VkKeyScan Lib "user32" Alias "VkKeyScanA" (ByVal cChar As Byte) As Integer
Private Declare Sub keybd_event Lib "user32" (ByVal bVk As Byte, ByVal bScan As Byte, ByVal dwFlags As Long, ByVal dwExtraInfo As Long)

Private Const KEYEVENTF_KEYDOWN As Long = &H0
Private Const KEYEVENTF_KEYUP As Long = &H2

Private Type VKType
 Alt As Boolean
 Control As Boolean
 Shift As Boolean
 VKCode As Integer
 scanCode As Integer
End Type

Public Sub SendDOSKeys(ByVal KeyString As String, Optional KeyWaitMilliSeconds As Long = 0)
'.------------------------------------------------------------------------------
'.  Funktion :  Sendet eine Zeichenfolge an ein Programm.
'.              Diese Funktion verhlt sich quivalent zum VB-Befehl Sendkeys.
'.              Die Eigenschaften dieser Funktion knnen aus der Hilfe
'.              entnommen werden.
'.
'.
'.  Vorauss. : -
'.
'.  Parameter: Keystring           - Enthlt die Zeichenfolge, die an das Programm
'.                                   gesendet werden soll.
'.             KeyWaitMilliSeconds - Wartezeit nach jedem Tastendruck
'.  Rckgabe : -
'.
'.      Autor:  Frank Heindrfer 10.10.2003
'.   gendert:
'.------------------------------------------------------------------------------
 Dim kCount As Long, i As Long, j As Long, iAKey As Integer, iVKey As Integer, _
  bShiftKey As Boolean, bControlKey As Boolean, bAltKey As Boolean, sKey As String, _
  iKey As Integer, OEMChar As String, kScan As Integer

  
 Static bInitialized As Boolean
 Static AKeys(0 To 255) As VKType
 Static VKeys(0 To 255) As VKType
  
 If bInitialized = False Then
  For iKey = LBound(AKeys) To UBound(AKeys)
   kScan = VkKeyScan(iKey)
   AKeys(iKey).VKCode = kScan And &HFF
   AKeys(iKey).Shift = kScan And &H100
   AKeys(iKey).Control = kScan And &H200
   AKeys(iKey).Alt = kScan And &H400
   OEMChar = "  "
   CharToOem Chr(iKey), OEMChar
   AKeys(iKey).scanCode = OemKeyScan(Asc(OEMChar)) And &HFF
  Next iKey
  
  For iKey = LBound(VKeys) To UBound(VKeys)
   VKeys(iKey).VKCode = iKey
   VKeys(iKey).scanCode = MapVirtualKey(iKey, 0)
  Next iKey
  bInitialized = True
 End If
  
 Do While Len(KeyString)
  kCount = 1
  bShiftKey = False: bControlKey = False: bAltKey = False
  sKey = Left$(KeyString, 1): KeyString = Mid$(KeyString, 2)
  
'  Do While InStr(" ^%+", sKey) > 1
  Do While InStr(" ^%+", sKey) > 1 And sKey <> "{"
   If sKey = "+" Then
     bShiftKey = True
    ElseIf sKey = "^" Then
     bControlKey = True
    ElseIf sKey = "%" Then
     bAltKey = True
   End If
   sKey = Left$(KeyString, 1)
   KeyString = Mid$(KeyString, 2)
  Loop
        
  If sKey = "{" Then
   i = InStr(KeyString, "}")
   If i > 0 Then
    sKey = Left$(KeyString, i - 1)
    KeyString = Mid$(KeyString, i + 1)
   End If
   i = Len(sKey)
   Do While Mid$(sKey, i, 1) >= "0" And Mid$(sKey, i, 1) <= "9" And i >= 3
    i = i - 1
   Loop
   If i < Len(sKey) Then
    If i >= 2 Then
     If Mid$(sKey, i, 1) = " " Then
      On Error Resume Next
      kCount = CLng(Mid$(sKey, i + 1))
      On Error GoTo 0
      sKey = Left$(sKey, i - 1)
     End If
    End If
   End If
  End If
        
  Select Case UCase$(sKey)
   Case "LBUTTON"
    iVKey = vbKeyLButton
   Case "RBUTTON"
    iVKey = vbKeyRButton
   Case "BREAK", "CANCEL"
    iVKey = vbKeyCancel
   Case "MBUTTON"
    iVKey = vbKeyMButton
   Case "BACKSPACE", "BS", "BKSP"
    iVKey = vbKeyBack
   Case "TAB"
    iVKey = vbKeyTab
   Case "CLEAR"
    iVKey = vbKeyClear
   Case "ENTER", "~"
    iVKey = vbKeyReturn
   Case "SHIFT"
    iVKey = vbKeyShift
   Case "CONTROL"
    iVKey = vbKeyControl
   Case "MENU", "ALT"
    iVKey = vbKeyMenu
   Case "PAUSE"
    iVKey = vbKeyPause
   Case "CAPSLOCK"
    iVKey = vbKeyCapital
   Case "ESCAPE", "ESC"
    iVKey = vbKeyEscape
   Case "SPACE"
    iVKey = vbKeySpace
   Case "PGUP"
    iVKey = vbKeyPageUp
   Case "PGDN"
    iVKey = vbKeyPageDown
   Case "END"
    iVKey = vbKeyEnd
   Case "HOME"
    iVKey = vbKeyHome
   Case "LEFT"
    iVKey = vbKeyLeft
   Case "UP"
    iVKey = vbKeyUp
   Case "RIGHT"
    iVKey = vbKeyRight
   Case "DOWN"
    iVKey = vbKeyDown
   Case "SELECT"
    iVKey = vbKeySelect
   Case "PRTSC"
    iVKey = vbKeyPrint
   Case "EXECUTE"
    iVKey = vbKeyExecute
   Case "SNAPSHOT"
    iVKey = vbKeySnapshot
   Case "INSERT", "INS"
    iVKey = vbKeyInsert
   Case "DELETE", "DEL"
    iVKey = vbKeyDelete
   Case "HELP"
    iVKey = vbKeyHelp
   Case "NUMLOCK"
    iVKey = vbKeyNumlock
   Case "SCROLLLOCK"
    iVKey = vbKeyScrollLock
   Case "NUMPAD0"
    iVKey = vbKeyNumpad0
   Case "NUMPAD1"
    iVKey = vbKeyNumpad1
   Case "NUMPAD2"
    iVKey = vbKeyNumpad2
   Case "NUMPAD3"
    iVKey = vbKeyNumpad3
   Case "NUMPAD4"
    iVKey = vbKeyNumpad4
   Case "NUMPAD5"
    iVKey = vbKeyNumpad5
   Case "NUMPAD6"
    iVKey = vbKeyNumpad6
   Case "NUMPAD7"
    iVKey = vbKeyNumpad7
   Case "NUMPAD8"
    iVKey = vbKeyNumpad8
   Case "NUMPAD9"
    iVKey = vbKeyNumpad9
   Case "MULTIPLY"
    iVKey = vbKeyMultiply
   Case "ADD"
    iVKey = vbKeyAdd
   Case "SEPARATOR"
    iVKey = vbKeySeparator
   Case "SUBTRACT"
    iVKey = vbKeySubtract
   Case "DECIMAL"
    iVKey = vbKeyDecimal
   Case "DIVIDE"
    iVKey = vbKeyDivide
   Case "F1"
    iVKey = vbKeyF1
   Case "F2"
    iVKey = vbKeyF2
   Case "F3"
    iVKey = vbKeyF3
   Case "F4"
    iVKey = vbKeyF4
   Case "F5"
    iVKey = vbKeyF5
   Case "F6"
    iVKey = vbKeyF6
   Case "F7"
    iVKey = vbKeyF7
   Case "F8"
    iVKey = vbKeyF8
   Case "F9"
    iVKey = vbKeyF9
   Case "F10"
    iVKey = vbKeyF10
   Case "F11"
    iVKey = vbKeyF11
   Case "F12"
    iVKey = vbKeyF12
   Case "F13"
    iVKey = vbKeyF13
   Case "F14"
    iVKey = vbKeyF14
   Case "F15"
    iVKey = vbKeyF15
   Case "F16"
    iVKey = vbKeyF16
   Case Else
    iVKey = -1
  End Select
        
  AppActivate TaskID
  
  If bShiftKey = True Then
   keybd_event VKeys(vbKeyShift).VKCode, VKeys(vbKeyShift).scanCode, KEYEVENTF_KEYDOWN, 0
  End If
        
  If bControlKey = True Then
   keybd_event VKeys(vbKeyControl).VKCode, VKeys(vbKeyControl).scanCode, KEYEVENTF_KEYDOWN, 0
  End If
        
  If bAltKey = True Then
   keybd_event VKeys(vbKeyMenu).VKCode, VKeys(vbKeyMenu).scanCode, KEYEVENTF_KEYDOWN, 0
  End If
  
  For i = 1 To kCount
   If iVKey > -1 Then
     keybd_event VKeys(iVKey).VKCode, VKeys(iVKey).scanCode, KEYEVENTF_KEYDOWN, 0
     keybd_event VKeys(iVKey).VKCode, VKeys(iVKey).scanCode, KEYEVENTF_KEYUP, 0
    Else
     For j = 1 To Len(sKey)
      iAKey = Asc(Mid$(sKey, j, 1))
      If bShiftKey = False Then
       If AKeys(iAKey).Shift = True Then
        keybd_event VKeys(vbKeyShift).VKCode, VKeys(vbKeyShift).scanCode, KEYEVENTF_KEYDOWN, 0
       End If
      End If
      If bControlKey = False Then
       If AKeys(iAKey).Control = True Then
        keybd_event VKeys(vbKeyControl).VKCode, VKeys(vbKeyControl).scanCode, KEYEVENTF_KEYDOWN, 0
       End If
      End If
      If bAltKey = False Then
       If AKeys(iAKey).Alt = True Then
        keybd_event VKeys(vbKeyMenu).VKCode, VKeys(vbKeyMenu).scanCode, KEYEVENTF_KEYDOWN, 0
       End If
      End If
      keybd_event AKeys(iAKey).VKCode, AKeys(iAKey).scanCode, KEYEVENTF_KEYDOWN, 0
      keybd_event AKeys(iAKey).VKCode, AKeys(iAKey).scanCode, KEYEVENTF_KEYUP, 0
        
      If bShiftKey = False Then
       If AKeys(iAKey).Shift = True Then
        keybd_event VKeys(vbKeyShift).VKCode, VKeys(vbKeyShift).scanCode, KEYEVENTF_KEYUP, 0
       End If
      End If
      
      If bControlKey = False Then
       If AKeys(iAKey).Control = True Then
        keybd_event VKeys(vbKeyControl).VKCode, VKeys(vbKeyControl).scanCode, KEYEVENTF_KEYUP, 0
       End If
      End If
      
      If bAltKey = False Then
       If AKeys(iAKey).Alt = True Then
        keybd_event VKeys(vbKeyMenu).VKCode, VKeys(vbKeyMenu).scanCode, KEYEVENTF_KEYUP, 0
       End If
      End If
     Next j
   End If
  Next i
        
  If bShiftKey = True Then
   keybd_event VKeys(vbKeyShift).VKCode, VKeys(vbKeyShift).scanCode, KEYEVENTF_KEYUP, 0
  End If
        
  If bControlKey = True Then
   keybd_event VKeys(vbKeyControl).VKCode, VKeys(vbKeyControl).scanCode, KEYEVENTF_KEYUP, 0
  End If
        
  If bAltKey = True Then
   keybd_event VKeys(vbKeyMenu).VKCode, VKeys(vbKeyMenu).scanCode, KEYEVENTF_KEYUP, 0
  End If
  If KeyWaitMilliSeconds > 0 Then
   Sleep KeyWaitMilliSeconds
  End If
  DoEvents
 Loop
End Sub
